; Source created with Parsic Version 3.x

; at              : 09/01/03 12.22.13


; Project File    : C:\PROGRA~1\PARSIC\VARI\ALARMV5.PIC

; Project Version : 0.0.234

; Created         : 03/06/99 0.25.00

; Last change     : 09/01/03 12.22.02

	PROCESSOR 16F628

	INCLUDE P16F628.INC

	RADIX DEC


	__IDLOCS H'0000'

	__CONFIG _CP_OFF & _PWRTE_ON & _WDT_ON & _BODEN_ON & _INTRC_OSC_NOCLKOUT & _LVP_OFF & _MCLRE_OFF

; Diverses

ZERO	EQU Z	; ZERO-Flag
CARRY	 EQU C	; CARRY-Flag


; Variable

S1	= 32	; located in Bank 0
S2	= 33	; located in Bank 0
OS1_FD	= 34	; located in Bank 0
OS2_FD	= 35	; located in Bank 0
OS3_FD	= 36	; located in Bank 0
OS4_FD	= 37	; located in Bank 0
S7	= 38	; located in Bank 0
ZR1	= 39	; located in Bank 0
ZR1_FD	= 40	; located in Bank 0
TR1	= 41	; located in Bank 0
TR1_HI	= 42	; located in Bank 0
MF1	= 43	; located in Bank 0
MF1_HI	= 44	; located in Bank 0
MF1_FD	= 45	; located in Bank 0
LT1_FD	= 46	; located in Bank 0
TR2	= 47	; located in Bank 0
TR2_HI	= 48	; located in Bank 0
S3	= 49	; located in Bank 0
MF2	= 50	; located in Bank 0
MF2_HI	= 51	; located in Bank 0
MF3	= 52	; located in Bank 0
MF3_HI	= 53	; located in Bank 0
LT2_FD	= 54	; located in Bank 0
OS5_FD	= 55	; located in Bank 0
LT3_FD	= 56	; located in Bank 0
LT4_FD	= 57	; located in Bank 0
OS6_FD	= 58	; located in Bank 0
LT5_FD	= 59	; located in Bank 0
OS7_FD	= 60	; located in Bank 0
S4	= 61	; located in Bank 0
TR3	= 62	; located in Bank 0
TR3_HI	= 63	; located in Bank 0
LT6_FD	= 64	; located in Bank 0
OS8_FD	= 65	; located in Bank 0
LT7_FD	= 66	; located in Bank 0
LT8_FD	= 67	; located in Bank 0
TR4	= 68	; located in Bank 0
TR4_HI	= 69	; located in Bank 0
S5	= 70	; located in Bank 0
S6	= 71	; located in Bank 0
ZR2	= 72	; located in Bank 0
ZR2_FD	= 73	; located in Bank 0
TR5	= 74	; located in Bank 0
TR5_HI	= 75	; located in Bank 0
S0	= 76	; located in Bank 0
OS9_FD	= 77	; located in Bank 0
OS10_FD	= 78	; located in Bank 0
OS11_FD	= 79	; located in Bank 0
OS12_FD	= 80	; located in Bank 0
OS13_FD	= 81	; located in Bank 0
LT9_FD	= 82	; located in Bank 0
OS14_FD	= 83	; located in Bank 0
OS15_FD	= 84	; located in Bank 0
OS16_FD	= 85	; located in Bank 0
RAM	= 86	; located in Bank 0
SYS_WSAV	= 112	; located in Bank 0, 1, 2, 3
SYS_SSAV	= 113	; located in Bank 0, 1, 2, 3
SYS_TMP1	= 114	; located in Bank 0, 1, 2, 3
SYS_TMP2	= 115	; located in Bank 0, 1, 2, 3
SYS_TMP3	= 116	; located in Bank 0, 1, 2, 3
SYS_TMP4	= 117	; located in Bank 0, 1, 2, 3
SYS_TMP5	= 118	; located in Bank 0, 1, 2, 3
SYS_TMP6	= 119	; located in Bank 0, 1, 2, 3
SYS_TMP9	= 120	; located in Bank 0, 1, 2, 3
SYS_TMP10	= 121	; located in Bank 0, 1, 2, 3

	ERRORLEVEL -302	; disable warning (Bankswitching)
	ERRORLEVEL -306	; disable warning (Pageswitching)

;****************************************
;Programmanfang
;****************************************

	ORG 0

	CLRF STATUS	; switch to RAM-Bank 0
	GOTO SYS_INIT
	NOP
	NOP

;****************************************
;Interrupt-Adress
;****************************************

	MOVWF SYS_WSAV	; save register
	SWAPF STATUS,W
	CLRF STATUS	; bank 0
	MOVWF SYS_SSAV

	BCF INTCON,T0IF	; Interrupt quitieren

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	INCFSZ TR1,F
	GOTO SYS_INT_LABEL_0
	INCF TR1_HI,F

SYS_INT_LABEL_0
	INCFSZ MF1,F
	GOTO SYS_INT_LABEL_1
	INCF MF1_HI,F

SYS_INT_LABEL_1
	INCFSZ TR2,F
	GOTO SYS_INT_LABEL_2
	INCF TR2_HI,F

SYS_INT_LABEL_2
	INCFSZ MF2,F
	GOTO SYS_INT_LABEL_3
	INCF MF2_HI,F

SYS_INT_LABEL_3
	INCFSZ MF3,F
	GOTO SYS_INT_LABEL_4
	INCF MF3_HI,F

SYS_INT_LABEL_4
	INCFSZ TR3,F
	GOTO SYS_INT_LABEL_5
	INCF TR3_HI,F

SYS_INT_LABEL_5
	INCFSZ TR4,F
	GOTO SYS_INT_LABEL_6
	INCF TR4_HI,F

SYS_INT_LABEL_6
	INCFSZ TR5,F
	GOTO SYS_INT_LABEL_7
	INCF TR5_HI,F

SYS_INT_LABEL_7

EXITINT

	SWAPF SYS_SSAV,W	; Register zurck
	MOVWF STATUS
	SWAPF SYS_WSAV,F
	SWAPF SYS_WSAV,W

	RETFIE	; RETurn From Interrupt and Enable GIE


;****************************************
; Subroutines
;****************************************

;***************************************************
; Subroutines for LB1
;***************************************************

LCD_LB1_INIT
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF PORTB,4	; ir-register
LCD_LB1_L1
	CALL LCD_LB1_OUT4
	CLRWDT
	DECFSZ SYS_TMP1,F
	GOTO LCD_LB1_L1

	MOVFW PORTB
	ANDLW H'F0'
	IORLW B'0011'	; Function Set
	MOVWF PORTB

	BSF PORTB,5	; write
	BCF PORTB,5

	BSF SYS_TMP1,5	; wait
LCD_LB1_L2
	CALL LCD_LB1_OUT4
	CLRWDT
	DECFSZ SYS_TMP1,F
	GOTO LCD_LB1_L2

	BSF PORTB,5	; write
	BCF PORTB,5

	CALL LCD_LB1_OUT4

	BSF PORTB,5	; write
	BCF PORTB,5

	CALL LCD_LB1_OUT4

	BCF PORTB,0	; 4-Bit Interface

	BSF PORTB,5	; write
	BCF PORTB,5

	CALL LCD_LB1_OUT4

	MOVLW B'00101000'	; Function Set 4-Bit,2-Lines
	CALL LCD_LB1_OUT

	MOVLW B'00001100'	; Display on, Cursor off, Blink off
	CALL LCD_LB1_OUT

	MOVLW B'00000110'	; Entrymode set
	CALL LCD_LB1_OUT

LCD_LB1_CLR
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF PORTB,4	; ir-register
	MOVLW B'00000001'	; Display clear
	CALL LCD_LB1_OUT

	BSF SYS_TMP1,5	; wait
LCD_LB1_L3
	CALL LCD_LB1_OUT4
	CLRWDT
	DECFSZ SYS_TMP1,F
	GOTO LCD_LB1_L3
	GOTO LCD_LB1_OUT4

;***************************************************

LCD_LB1_GOTOXY
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF PORTB,4	; ir-register
	MOVLW H'40'
	BTFSC SYS_TMP2,0	; Ypos
	ADDWF SYS_TMP1,F
	BSF SYS_TMP1,7	; select dd-ram
	GOTO LCD_LB1_OUT1

;***************************************************

LCD_LB1_WRITESTR
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BSF PORTB,4	; dd-ram
LCD_LB1_WRITESTR1
	CALL LCD_LB1_CHAROUT
	BSF INTCON,GIE
	ANDLW H'FF'	; last is zero
	BTFSC STATUS,ZERO
	RETURN

	MOVWF SYS_TMP1
	CLRWDT
	CALL LCD_LB1_OUT1
	INCFSZ SYS_TMP4,F	; next char
	GOTO LCD_LB1_WRITESTR1
	INCF SYS_TMP5,F	; next page
	GOTO LCD_LB1_WRITESTR1

LCD_LB1_CHAROUT
	BCF INTCON,GIE
	MOVFW SYS_TMP5
	MOVWF PCLATH
	MOVFW SYS_TMP4
	MOVWF PCL

;***************************************************

LCD_LB1_DEZO10000

	MOVLW LOW 10000
	MOVWF SYS_TMP1
	MOVLW HIGH 10000
	MOVWF SYS_TMP2

	CALL LCD_LB1_CONVERTDEZ
	MOVF SYS_TMP9,F
	BTFSS STATUS,ZERO
	GOTO LCD_LB1_DEZO1000
	CALL LCD_LB1_CHECKNULL

LCD_LB1_DEZO1000

	MOVLW LOW 1000
	MOVWF SYS_TMP1
	MOVLW HIGH 1000
	MOVWF SYS_TMP2

	CALL LCD_LB1_CONVERTDEZ
	MOVF SYS_TMP9,F
	BTFSS STATUS,ZERO
	GOTO LCD_LB1_DEZO100
	CALL LCD_LB1_CHECKNULL

LCD_LB1_DEZO100

	MOVLW LOW 100
	MOVWF SYS_TMP1
	CLRF SYS_TMP2

	CALL LCD_LB1_CONVERTDEZ
	MOVF SYS_TMP9,F
	BTFSS STATUS,ZERO
	GOTO LCD_LB1_DEZO10
	CALL LCD_LB1_CHECKNULL

LCD_LB1_DEZO10

	MOVLW LOW 10
	MOVWF SYS_TMP1
	CLRF SYS_TMP2

	CALL LCD_LB1_CONVERTDEZ
	MOVF SYS_TMP9,F
	BTFSS STATUS,ZERO
	GOTO LCD_LB1_DEZO1
	CALL LCD_LB1_CHECKNULL

LCD_LB1_DEZO1
	MOVLW 48
	ADDWF SYS_TMP4,W
	GOTO LCD_LB1_WRITECHAR

;***************************************************

LCD_LB1_CONVERTDEZ
	MOVF SYS_TMP9,F
	BTFSS STATUS,ZERO
	DECF SYS_TMP9,F
	CLRF SYS_TMP6
LCD_LB1_CONVERTDEZ2
	INCF SYS_TMP6,F

	MOVFW SYS_TMP1
	SUBWF SYS_TMP4,F

	MOVFW SYS_TMP2
	BTFSS STATUS,CARRY
	INCFSZ SYS_TMP2,W
	SUBWF SYS_TMP5,F
	BTFSC STATUS,CARRY
	GOTO LCD_LB1_CONVERTDEZ2

	MOVFW SYS_TMP2
	ADDWF SYS_TMP5,F
	MOVFW SYS_TMP1
	ADDWF SYS_TMP4,F
	BTFSC STATUS,CARRY
	INCF SYS_TMP5,F

	DECF SYS_TMP6,W
	BTFSS STATUS,ZERO
	BSF SYS_TMP10,0
	RETURN

;***************************************************

LCD_LB1_CONVERTHEX
	ANDLW 15
	MOVWF SYS_TMP1
	MOVLW 48
	ADDWF SYS_TMP1,F
	MOVLW 58
	SUBWF SYS_TMP1,W
	BTFSS STATUS,CARRY
	GOTO $+3
	MOVLW 7
	ADDWF SYS_TMP1,F
	MOVFW SYS_TMP1

;***************************************************

LCD_LB1_WRITECHAR
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BSF PORTB,4	; dd-ram

;***************************************************

LCD_LB1_OUT
	MOVWF SYS_TMP1	; store
LCD_LB1_OUT1
	CLRF SYS_TMP3	; LCDWriteStr (first nibble)
LCD_LB1_OUT2
	SWAPF SYS_TMP1,W	;high nibble
LCD_LB1_OUT3
	ANDLW H'0F'	; mask
	MOVWF SYS_TMP2	; store
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVFW PORTB	; load port
	ANDLW H'F0'	; mask
	IORWF SYS_TMP2,W	; add cmd
	MOVWF PORTB	; out

	BSF PORTB,5	; E high
	BCF PORTB,5	; E low

	BTFSC SYS_TMP3,3	; ready ?
	GOTO LCD_LB1_OUT4	; yes
	BSF SYS_TMP3,3	; second nibble
	MOVFW SYS_TMP1
	GOTO LCD_LB1_OUT3	; next nibble

LCD_LB1_OUT4
LCD_LB1_OUTV
	DECFSZ SYS_TMP3,F
	GOTO LCD_LB1_OUTV
	RETURN

;***************************************************

LCD_LB1_CHECKNULL
	BTFSS STATUS,ZERO
	DECF SYS_TMP9,F
	MOVWF SYS_TMP1
	BTFSS STATUS,ZERO
	BSF SYS_TMP10,0
	MOVLW 48
	BTFSC SYS_TMP10,0
	ADDWF SYS_TMP1,f
	MOVLW 32
	BTFSS SYS_TMP10,0
	ADDWF SYS_TMP1,F
	MOVFW SYS_TMP1
	GOTO LCD_LB1_WRITECHAR
; 00DD

;****************************************
;Initialisierung
;****************************************


SYS_INIT

	MOVLW B'00100000'
	MOVWF INTCON

; Ausgangs-Pegel setzen, bevor die Richtung gesetzt wird

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVLW B'00000000'
	MOVWF PORTA

	MOVLW B'00000000'
	MOVWF PORTB

	MOVLW 15
	BSF STATUS,RP0	; Bank 1
	MOVWF OPTION_REG


; Richtung setzen

	MOVLW B'10111111'
	MOVWF TRISA

	MOVLW B'00000000'
	MOVWF TRISB

	BCF STATUS,RP0	; Bank 0
	MOVLW 7	; Comparators off
	MOVWF CMCON
; init vars


; Clear RAM

	BCF STATUS,IRP
	MOVLW 32
	MOVWF FSR
CR1
	CLRF INDF
	INCF FSR,F
	BTFSS FSR,7
	GOTO CR1
	BSF FSR,5
CR2
	CLRF INDF
	INCF FSR,F
	MOVLW H'F0'
	SUBWF FSR,W
	BTFSS STATUS,ZERO
	GOTO CR2
	BSF STATUS,IRP
	MOVLW 32
	MOVWF FSR
CR3
	CLRF INDF
	INCF FSR,F
	MOVLW H'50'
	SUBWF FSR,W
	BTFSS STATUS,ZERO
	GOTO CR3


;***************************************************
; Init LCD -> LB1
;***************************************************

	CALL LCD_LB1_INIT

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	CLRF TMR0
	BCF INTCON,T0IF
	BSF INTCON,GIE	; Interrupt freigeben

;**********************************
;******* Haupt-Programm ***********
;**********************************

MAIN

	CLRWDT

;***************************************************
; ODER - Gatter -> LG1
;***************************************************

LABEL_LG1_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S2,1
	GOTO LABEL_LG1_TRUE
LABEL_LG1_2
	BTFSC S2,2
	GOTO LABEL_LG1_TRUE
LABEL_LG1_3
	BTFSC S2,3
	GOTO LABEL_LG1_TRUE
LABEL_LG1_4
	BTFSC S2,4
	GOTO LABEL_LG1_TRUE

LABEL_LG1_FALSE
	BCF S1,7
	GOTO LABEL_LG1_ENDE
LABEL_LG1_TRUE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BSF S1,7
LABEL_LG1_ENDE
;***************************************************
; One Shot -> OS1
;***************************************************


	BTFSS PORTA,1
	GOTO LABEL_OS1_1
	BTFSC OS1_FD,0
	GOTO LABEL_OS1_1
	BSF OS1_FD,0
	BSF S2,1
	GOTO LABEL_OS1_2
LABEL_OS1_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S2,1
	BTFSC PORTA,1
	GOTO LABEL_OS1_2
	BCF OS1_FD,0
LABEL_OS1_2
;***************************************************
; One Shot -> OS2
;***************************************************


	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS PORTA,2
	GOTO LABEL_OS2_1
	BTFSC OS2_FD,0
	GOTO LABEL_OS2_1
	BSF OS2_FD,0
	BSF S2,2
	GOTO LABEL_OS2_2
LABEL_OS2_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S2,2
	BTFSC PORTA,2
	GOTO LABEL_OS2_2
	BCF OS2_FD,0
LABEL_OS2_2
;***************************************************
; One Shot -> OS3
;***************************************************


	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS PORTA,4
	GOTO LABEL_OS3_1
	BTFSC OS3_FD,0
	GOTO LABEL_OS3_1
	BSF OS3_FD,0
	BSF S2,4
	GOTO LABEL_OS3_2
LABEL_OS3_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S2,4
	BTFSC PORTA,4
	GOTO LABEL_OS3_2
	BCF OS3_FD,0
LABEL_OS3_2
;***************************************************
; One Shot -> OS4
;***************************************************


	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S1,0
	GOTO LABEL_OS4_1
	BTFSC OS4_FD,0
	GOTO LABEL_OS4_1
	BSF OS4_FD,0
	BSF S1,1
	GOTO LABEL_OS4_2
LABEL_OS4_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S1,1
	BTFSC S1,0
	GOTO LABEL_OS4_2
	BCF OS4_FD,0
LABEL_OS4_2
;***************************************************
; ODER - Gatter -> LG2
;***************************************************

LABEL_LG2_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S1,1
	GOTO LABEL_LG2_TRUE
LABEL_LG2_2
	BTFSC S1,6
	GOTO LABEL_LG2_TRUE

LABEL_LG2_FALSE
	BCF S7,1
	GOTO LABEL_LG2_ENDE
LABEL_LG2_TRUE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BSF S7,1
LABEL_LG2_ENDE
;***************************************************
; RS-FLIP-FLOP -> RS1
;***************************************************

	BTFSC S7,4
	GOTO LABEL_RS1_RESET
	BTFSS S7,1
	GOTO LABEL_RS1_ENDE
	BSF PORTB,6	; Ausgang setzen
	GOTO LABEL_RS1_ENDE
LABEL_RS1_RESET
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF PORTB,6	; Ausgang zurcksetzen
LABEL_RS1_ENDE

;***************************************************
; Zhler -> ZR1
;***************************************************

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S1,5	; Reset ?
	GOTO LABEL_ZR1_COUNT
	CLRF ZR1
	GOTO LABEL_ZR1_SETOUT

LABEL_ZR1_COUNT

; Test auf positive Flanke

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC ZR1_FD,0
	GOTO LABEL_ZR1_SETFD
	BTFSS S1,3
	GOTO LABEL_ZR1_SETFD

	INCF ZR1,F

LABEL_ZR1_SETOUT

; Output Q0

	BTFSS ZR1,0
	GOTO LABEL_ZR1_SETOUT0
	BSF S1,3
	GOTO LABEL_ZR1_SETOUT0_END
LABEL_ZR1_SETOUT0
	BCF S1,3
LABEL_ZR1_SETOUT0_END

LABEL_ZR1_SETFD

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S1,3
	GOTO LABEL_ZR1_SETFD2
	BSF ZR1_FD,0
	GOTO LABEL_ZR1_END
LABEL_ZR1_SETFD2
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF ZR1_FD,0
LABEL_ZR1_END

;***************************************************
; Vergleich -> IF1
;***************************************************

	MOVLW 90
	SUBWF ZR1,W	; F - W -> W

LABEL_IF1_CHECK
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS STATUS,ZERO	; Test auf -> =
	GOTO LABEL_IF1_FALSE

LABEL_IF1_TRUE
	BSF S1,4
	GOTO LABEL_IF1_EXIT

LABEL_IF1_FALSE
	BCF S1,4

LABEL_IF1_EXIT
;***************************************************
; Timer -> TR1
;***************************************************

	MOVLW 15	; Test auf >=
	SUBWF TR1_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR1_CHECK
	MOVLW 66
	SUBWF TR1,W	;F-W -> W
LABEL_TR1_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR1_ENDE

LABEL_TR1_RESET
	MOVLW 15	; Test auf >=
	SUBWF TR1_HI,F	;F-W -> F
	MOVLW 66
	SUBWF TR1,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR1_HI,F

LABEL_TR1_SET	; toggel output
	BTFSC S1,2
	GOTO LABEL_TR1_CLR
	BSF S1,2
	GOTO LABEL_TR1_ENDE
LABEL_TR1_CLR
	BCF S1,2
LABEL_TR1_ENDE

;***************************************************
; UND - Gatter -> LG3
;***************************************************

LABEL_LG3_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S1,2
	GOTO LABEL_LG3_FALSE
LABEL_LG3_2
	BTFSS PORTB,6
	GOTO LABEL_LG3_FALSE

LABEL_LG3_TRUE
	BSF S1,3
	GOTO LABEL_LG3_ENDE
LABEL_LG3_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S1,3
LABEL_LG3_ENDE
;***************************************************
; ODER - Gatter -> LG4
;***************************************************

LABEL_LG4_1
	BTFSC S1,4
	GOTO LABEL_LG4_TRUE
LABEL_LG4_2
	BTFSC S1,6
	GOTO LABEL_LG4_TRUE

LABEL_LG4_FALSE
	BCF S1,5
	GOTO LABEL_LG4_ENDE
LABEL_LG4_TRUE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BSF S1,5
LABEL_LG4_ENDE
;***************************************************
; UND - Gatter -> LG5
;***************************************************

LABEL_LG5_1
	BTFSS S2,0
	GOTO LABEL_LG5_FALSE
LABEL_LG5_2
	BTFSS S1,7
	GOTO LABEL_LG5_FALSE

LABEL_LG5_TRUE
	BSF S1,0
	GOTO LABEL_LG5_ENDE
LABEL_LG5_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S1,0
LABEL_LG5_ENDE
;***************************************************
; Mono-Flop -> MF1
;***************************************************

; Test auf positive Flanke

	BTFSC MF1_FD,0
	GOTO LABEL_MF1_CHKTIME
	BTFSS S2,4
	GOTO LABEL_MF1_CHKTIME


LABEL_MF1_RESET

	CLRF MF1
	CLRF MF1_HI
	BSF MF1_FD,1
	BSF S1,6

LABEL_MF1_CHKTIME

; Luft der Impuls ?

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS MF1_FD,1
	GOTO LABEL_MF1_SETFD

	MOVLW 7
	SUBWF MF1_HI,W
	BTFSS STATUS,ZERO
	GOTO LABEL_MF1_CHECK
	MOVLW 161
	SUBWF MF1,W
LABEL_MF1_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_MF1_SETFD
LABEL_MF1_TO

	BCF MF1_FD,1
	BCF S1,6

LABEL_MF1_SETFD

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S2,4
	GOTO LABEL_MF1_CLR
	BSF MF1_FD,0
	GOTO LABEL_MF1_ENDE
LABEL_MF1_CLR
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF MF1_FD,0

LABEL_MF1_ENDE

;***************************************************
; LCD -> LT1
;***************************************************

; test of positiv edge

	BTFSC LT1_FD,0
	GOTO LABEL_LT1_SETFD
	BTFSS S3,1
	GOTO LABEL_LT1_SETFD


	MOVLW 0
	MOVWF SYS_TMP1
	MOVLW 0
	MOVWF SYS_TMP2

	CALL LCD_LB1_GOTOXY

	MOVLW LOW TAB_LT1
	MOVWF SYS_TMP4
	MOVLW HIGH TAB_LT1
	MOVWF SYS_TMP5


	CALL LCD_LB1_WRITESTR

LABEL_LT1_SETFD

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S3,1
	GOTO LABEL_LT1_SETFD2
	BSF LT1_FD,0
	GOTO LABEL_LT1_END
LABEL_LT1_SETFD2
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF LT1_FD,0
LABEL_LT1_END

;***************************************************
; Timer -> TR2
;***************************************************

	MOVLW 0	; Test auf >=
	SUBWF TR2_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR2_CHECK
	MOVLW 195
	SUBWF TR2,W	;F-W -> W
LABEL_TR2_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR2_ENDE

LABEL_TR2_RESET
	MOVLW 0	; Test auf >=
	SUBWF TR2_HI,F	;F-W -> F
	MOVLW 195
	SUBWF TR2,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR2_HI,F

LABEL_TR2_SET	; toggel output
	BTFSC S2,5
	GOTO LABEL_TR2_CLR
	BSF S2,5
	GOTO LABEL_TR2_ENDE
LABEL_TR2_CLR
	BCF S2,5
LABEL_TR2_ENDE

;***************************************************
; UND - Gatter -> LG6
;***************************************************

LABEL_LG6_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC PORTA,0
	GOTO LABEL_LG6_FALSE
LABEL_LG6_2
	BTFSS S2,5
	GOTO LABEL_LG6_FALSE

LABEL_LG6_TRUE
	BSF S3,2
	GOTO LABEL_LG6_ENDE
LABEL_LG6_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S3,2
LABEL_LG6_ENDE
;***************************************************
; UND - Gatter -> LG7
;***************************************************

LABEL_LG7_1
	BTFSC PORTA,1
	GOTO LABEL_LG7_FALSE
LABEL_LG7_2
	BTFSC PORTA,2
	GOTO LABEL_LG7_FALSE
LABEL_LG7_3
	BTFSC PORTA,3
	GOTO LABEL_LG7_FALSE
LABEL_LG7_4
	BTFSC PORTA,4
	GOTO LABEL_LG7_FALSE

LABEL_LG7_TRUE
	BSF S2,6
	GOTO LABEL_LG7_ENDE
LABEL_LG7_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S2,6
LABEL_LG7_ENDE
;***************************************************
; Anzug-Verzgerung -> MF2
;***************************************************

	BTFSC PORTA,3	; Eingang auf High ?
	GOTO LABEL_MF2_CHKTIME	; Ja

; RESET

	CLRF MF2
	CLRF MF2_HI
	BCF S2,3
	GOTO LABEL_MF2_EXIT	; raus

LABEL_MF2_CHKTIME

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S2,3	; Ausgang schon auf High ?
	GOTO LABEL_MF2_EXIT	; Ja

	MOVLW 76
	SUBWF MF2_HI,W
	BTFSS STATUS,CARRY
	GOTO LABEL_MF2_EXIT

	MOVLW 75
	SUBWF MF2,W
	BTFSS STATUS,CARRY
	GOTO LABEL_MF2_EXIT

	BSF S2,3
LABEL_MF2_EXIT

;***************************************************
; Anzug-Verzgerung -> MF3
;***************************************************

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC PORTA,0	; Eingang auf High ?
	GOTO LABEL_MF3_CHKTIME	; Ja

; RESET

	CLRF MF3
	CLRF MF3_HI
	BCF S2,0
	GOTO LABEL_MF3_EXIT	; raus

LABEL_MF3_CHKTIME

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S2,0	; Ausgang schon auf High ?
	GOTO LABEL_MF3_EXIT	; Ja

	MOVLW 228
	SUBWF MF3_HI,W
	BTFSS STATUS,CARRY
	GOTO LABEL_MF3_EXIT

	MOVLW 226
	SUBWF MF3,W
	BTFSS STATUS,CARRY
	GOTO LABEL_MF3_EXIT

	BSF S2,0
LABEL_MF3_EXIT

;***************************************************
; UND - Gatter -> LG8
;***************************************************

LABEL_LG8_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S2,5
	GOTO LABEL_LG8_FALSE
LABEL_LG8_2
	BTFSS S2,6
	GOTO LABEL_LG8_FALSE
LABEL_LG8_3
	BTFSC PORTA,0
	GOTO LABEL_LG8_FALSE

LABEL_LG8_TRUE
	BSF S3,0
	GOTO LABEL_LG8_ENDE
LABEL_LG8_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S3,0
LABEL_LG8_ENDE
;***************************************************
; LCD -> LT2
;***************************************************

; test of positiv edge

	BTFSC LT2_FD,0
	GOTO LABEL_LT2_SETFD
	BTFSS S2,7
	GOTO LABEL_LT2_SETFD


	MOVLW 0
	MOVWF SYS_TMP1
	MOVLW 1
	MOVWF SYS_TMP2

	CALL LCD_LB1_GOTOXY

	MOVLW LOW TAB_LT2
	MOVWF SYS_TMP4
	MOVLW HIGH TAB_LT2
	MOVWF SYS_TMP5


	CALL LCD_LB1_WRITESTR

LABEL_LT2_SETFD

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S2,7
	GOTO LABEL_LT2_SETFD2
	BSF LT2_FD,0
	GOTO LABEL_LT2_END
LABEL_LT2_SETFD2
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF LT2_FD,0
LABEL_LT2_END

;***************************************************
; One Shot -> OS5
;***************************************************


	BTFSS S3,0
	GOTO LABEL_OS5_1
	BTFSC OS5_FD,0
	GOTO LABEL_OS5_1
	BSF OS5_FD,0
	BSF S2,7
	GOTO LABEL_OS5_2
LABEL_OS5_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S2,7
	BTFSC S3,0
	GOTO LABEL_OS5_2
	BCF OS5_FD,0
LABEL_OS5_2
;***************************************************
; LCD -> LT3
;***************************************************

; test of positiv edge

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC LT3_FD,0
	GOTO LABEL_LT3_SETFD
	BTFSS S3,3
	GOTO LABEL_LT3_SETFD


	MOVLW 0
	MOVWF SYS_TMP1
	MOVLW 0
	MOVWF SYS_TMP2

	CALL LCD_LB1_GOTOXY

	MOVLW LOW TAB_LT3
	MOVWF SYS_TMP4
	MOVLW HIGH TAB_LT3
	MOVWF SYS_TMP5


	CALL LCD_LB1_WRITESTR

LABEL_LT3_SETFD

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S3,3
	GOTO LABEL_LT3_SETFD2
	BSF LT3_FD,0
	GOTO LABEL_LT3_END
LABEL_LT3_SETFD2
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF LT3_FD,0
LABEL_LT3_END

;***************************************************
; LCD -> LT4
;***************************************************

; test of positiv edge

	BTFSC LT4_FD,0
	GOTO LABEL_LT4_SETFD
	BTFSS S5,5
	GOTO LABEL_LT4_SETFD


	MOVLW 0
	MOVWF SYS_TMP1
	MOVLW 0
	MOVWF SYS_TMP2

	CALL LCD_LB1_GOTOXY

	MOVLW LOW TAB_LT4
	MOVWF SYS_TMP4
	MOVLW HIGH TAB_LT4
	MOVWF SYS_TMP5


	CALL LCD_LB1_WRITESTR

LABEL_LT4_SETFD

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S5,5
	GOTO LABEL_LT4_SETFD2
	BSF LT4_FD,0
	GOTO LABEL_LT4_END
LABEL_LT4_SETFD2
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF LT4_FD,0
LABEL_LT4_END

;***************************************************
; One Shot -> OS6
;***************************************************


	BTFSS S3,2
	GOTO LABEL_OS6_1
	BTFSC OS6_FD,0
	GOTO LABEL_OS6_1
	BSF OS6_FD,0
	BSF S3,1
	GOTO LABEL_OS6_2
LABEL_OS6_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S3,1
	BTFSC S3,2
	GOTO LABEL_OS6_2
	BCF OS6_FD,0
LABEL_OS6_2
;***************************************************
; LCD -> LT5
;***************************************************

; test of positiv edge

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC LT5_FD,0
	GOTO LABEL_LT5_SETFD
	BTFSS S5,4
	GOTO LABEL_LT5_SETFD


	MOVLW 0
	MOVWF SYS_TMP1
	MOVLW 1
	MOVWF SYS_TMP2

	CALL LCD_LB1_GOTOXY

	MOVLW LOW TAB_LT5
	MOVWF SYS_TMP4
	MOVLW HIGH TAB_LT5
	MOVWF SYS_TMP5


	CALL LCD_LB1_WRITESTR

LABEL_LT5_SETFD

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S5,4
	GOTO LABEL_LT5_SETFD2
	BSF LT5_FD,0
	GOTO LABEL_LT5_END
LABEL_LT5_SETFD2
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF LT5_FD,0
LABEL_LT5_END

;***************************************************
; UND - Gatter -> LG9
;***************************************************

LABEL_LG9_1
	BTFSS S2,5
	GOTO LABEL_LG9_FALSE
LABEL_LG9_2
	BTFSS PORTA,0
	GOTO LABEL_LG9_FALSE
LABEL_LG9_3
	BTFSS S2,0
	GOTO LABEL_LG9_FALSE

LABEL_LG9_TRUE
	BSF S3,4
	GOTO LABEL_LG9_ENDE
LABEL_LG9_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S3,4
LABEL_LG9_ENDE
;***************************************************
; One Shot -> OS7
;***************************************************


	BTFSS S3,4
	GOTO LABEL_OS7_1
	BTFSC OS7_FD,0
	GOTO LABEL_OS7_1
	BSF OS7_FD,0
	BSF S3,3
	GOTO LABEL_OS7_2
LABEL_OS7_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S3,3
	BTFSC S3,4
	GOTO LABEL_OS7_2
	BCF OS7_FD,0
LABEL_OS7_2
;***************************************************
; ODER - Gatter -> LG10
;***************************************************

LABEL_LG10_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S4,0
	GOTO LABEL_LG10_TRUE
LABEL_LG10_2
	BTFSC S3,7
	GOTO LABEL_LG10_TRUE
LABEL_LG10_3
	BTFSC S3,6
	GOTO LABEL_LG10_TRUE

LABEL_LG10_FALSE
	BCF S4,1
	GOTO LABEL_LG10_ENDE
LABEL_LG10_TRUE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BSF S4,1
LABEL_LG10_ENDE
;***************************************************
; UND - Gatter -> LG11
;***************************************************

LABEL_LG11_1
	BTFSS S4,1
	GOTO LABEL_LG11_FALSE
LABEL_LG11_2
	BTFSS S3,5
	GOTO LABEL_LG11_FALSE
LABEL_LG11_3
	BTFSS PORTA,0
	GOTO LABEL_LG11_FALSE

LABEL_LG11_TRUE
	BSF S4,2
	GOTO LABEL_LG11_ENDE
LABEL_LG11_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S4,2
LABEL_LG11_ENDE
;***************************************************
; Timer -> TR3
;***************************************************

	MOVLW 7	; Test auf >=
	SUBWF TR3_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR3_CHECK
	MOVLW 161
	SUBWF TR3,W	;F-W -> W
LABEL_TR3_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR3_ENDE

LABEL_TR3_RESET
	MOVLW 7	; Test auf >=
	SUBWF TR3_HI,F	;F-W -> F
	MOVLW 161
	SUBWF TR3,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR3_HI,F

LABEL_TR3_SET	; toggel output
	BTFSC S3,5
	GOTO LABEL_TR3_CLR
	BSF S3,5
	GOTO LABEL_TR3_ENDE
LABEL_TR3_CLR
	BCF S3,5
LABEL_TR3_ENDE

;***************************************************
; LCD -> LT6
;***************************************************

; test of positiv edge

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC LT6_FD,0
	GOTO LABEL_LT6_SETFD
	BTFSS S6,6
	GOTO LABEL_LT6_SETFD


	MOVLW 0
	MOVWF SYS_TMP1
	MOVLW 1
	MOVWF SYS_TMP2

	CALL LCD_LB1_GOTOXY

	MOVLW LOW TAB_LT6
	MOVWF SYS_TMP4
	MOVLW HIGH TAB_LT6
	MOVWF SYS_TMP5


	CALL LCD_LB1_WRITESTR

LABEL_LT6_SETFD

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S6,6
	GOTO LABEL_LT6_SETFD2
	BSF LT6_FD,0
	GOTO LABEL_LT6_END
LABEL_LT6_SETFD2
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF LT6_FD,0
LABEL_LT6_END

;***************************************************
; ODER - Gatter -> LG12
;***************************************************

LABEL_LG12_1
	BTFSC S7,2
	GOTO LABEL_LG12_TRUE
LABEL_LG12_2
	BTFSC S1,4
	GOTO LABEL_LG12_TRUE
LABEL_LG12_3
	BTFSC S7,3
	GOTO LABEL_LG12_TRUE

LABEL_LG12_FALSE
	BCF S7,4
	GOTO LABEL_LG12_ENDE
LABEL_LG12_TRUE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BSF S7,4
LABEL_LG12_ENDE
;***************************************************
; One Shot -> OS8
;***************************************************


	BTFSS PORTA,5
	GOTO LABEL_OS8_1
	BTFSC OS8_FD,0
	GOTO LABEL_OS8_1
	BSF OS8_FD,0
	BSF S7,2
	GOTO LABEL_OS8_2
LABEL_OS8_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S7,2
	BTFSC PORTA,5
	GOTO LABEL_OS8_2
	BCF OS8_FD,0
LABEL_OS8_2
;***************************************************
; LCD -> LT7
;***************************************************

; test of positiv edge

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC LT7_FD,0
	GOTO LABEL_LT7_SETFD
	BTFSS S5,1
	GOTO LABEL_LT7_SETFD


	MOVLW 0
	MOVWF SYS_TMP1
	MOVLW 1
	MOVWF SYS_TMP2

	CALL LCD_LB1_GOTOXY

	MOVLW LOW TAB_LT7
	MOVWF SYS_TMP4
	MOVLW HIGH TAB_LT7
	MOVWF SYS_TMP5


	CALL LCD_LB1_WRITESTR

LABEL_LT7_SETFD

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S5,1
	GOTO LABEL_LT7_SETFD2
	BSF LT7_FD,0
	GOTO LABEL_LT7_END
LABEL_LT7_SETFD2
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF LT7_FD,0
LABEL_LT7_END

;***************************************************
; LCD -> LT8
;***************************************************

; test of positiv edge

	BTFSC LT8_FD,0
	GOTO LABEL_LT8_SETFD
	BTFSS S5,3
	GOTO LABEL_LT8_SETFD


	MOVLW 0
	MOVWF SYS_TMP1
	MOVLW 1
	MOVWF SYS_TMP2

	CALL LCD_LB1_GOTOXY

	MOVLW LOW TAB_LT8
	MOVWF SYS_TMP4
	MOVLW HIGH TAB_LT8
	MOVWF SYS_TMP5


	CALL LCD_LB1_WRITESTR

LABEL_LT8_SETFD

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S5,3
	GOTO LABEL_LT8_SETFD2
	BSF LT8_FD,0
	GOTO LABEL_LT8_END
LABEL_LT8_SETFD2
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF LT8_FD,0
LABEL_LT8_END

;***************************************************
; Timer -> TR4
;***************************************************

	MOVLW 3	; Test auf >=
	SUBWF TR4_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR4_CHECK
	MOVLW 209
	SUBWF TR4,W	;F-W -> W
LABEL_TR4_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR4_ENDE

LABEL_TR4_RESET
	MOVLW 3	; Test auf >=
	SUBWF TR4_HI,F	;F-W -> F
	MOVLW 209
	SUBWF TR4,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR4_HI,F

LABEL_TR4_SET	; toggel output
	BTFSC S4,3
	GOTO LABEL_TR4_CLR
	BSF S4,3
	GOTO LABEL_TR4_ENDE
LABEL_TR4_CLR
	BCF S4,3
LABEL_TR4_ENDE

;***************************************************
; ODER - Gatter -> LG13
;***************************************************

LABEL_LG13_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S4,2
	GOTO LABEL_LG13_TRUE
LABEL_LG13_2
	BTFSC S4,5
	GOTO LABEL_LG13_TRUE

LABEL_LG13_FALSE
	BCF PORTB,7
	GOTO LABEL_LG13_ENDE
LABEL_LG13_TRUE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BSF PORTB,7
LABEL_LG13_ENDE
;***************************************************
; UND - Gatter -> LG14
;***************************************************

LABEL_LG14_1
	BTFSS S4,3
	GOTO LABEL_LG14_FALSE
LABEL_LG14_2
	BTFSS S4,4
	GOTO LABEL_LG14_FALSE

LABEL_LG14_TRUE
	BSF S4,5
	GOTO LABEL_LG14_ENDE
LABEL_LG14_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S4,5
LABEL_LG14_ENDE
;***************************************************
; Verteiler -> BV1
;***************************************************

	BTFSC S0,0
	GOTO LABEL_BV1_0
	BCF S5,6
	GOTO LABEL_BV1_0_END
LABEL_BV1_0
	BSF S5,6
LABEL_BV1_0_END

;**********************************************

	BTFSC S0,1
	GOTO LABEL_BV1_1
	BCF S6,5
	GOTO LABEL_BV1_1_END
LABEL_BV1_1
	BSF S6,5
LABEL_BV1_1_END

;**********************************************

	BTFSC S0,2
	GOTO LABEL_BV1_2
	BCF S6,2
	GOTO LABEL_BV1_2_END
LABEL_BV1_2
	BSF S6,2
LABEL_BV1_2_END

;**********************************************

	BTFSC S0,3
	GOTO LABEL_BV1_3
	BCF S6,3
	GOTO LABEL_BV1_3_END
LABEL_BV1_3
	BSF S6,3
LABEL_BV1_3_END

;**********************************************

	BTFSC S0,4
	GOTO LABEL_BV1_4
	BCF S6,4
	GOTO LABEL_BV1_4_END
LABEL_BV1_4
	BSF S6,4
LABEL_BV1_4_END

;**********************************************


;***************************************************
; Zhler -> ZR2
;***************************************************

	BTFSS S4,7	; Reset ?
	GOTO LABEL_ZR2_COUNT
	CLRF ZR2
	GOTO LABEL_ZR2_SETOUT

LABEL_ZR2_COUNT

; Test auf positive Flanke

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC ZR2_FD,0
	GOTO LABEL_ZR2_SETFD
	BTFSS S4,6
	GOTO LABEL_ZR2_SETFD

	INCF ZR2,F

LABEL_ZR2_SETOUT

LABEL_ZR2_SETFD

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S4,6
	GOTO LABEL_ZR2_SETFD2
	BSF ZR2_FD,0
	GOTO LABEL_ZR2_END
LABEL_ZR2_SETFD2
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF ZR2_FD,0
LABEL_ZR2_END

;***************************************************
; Timer -> TR5
;***************************************************

	MOVLW 7	; Test auf >=
	SUBWF TR5_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR5_CHECK
	MOVLW 161
	SUBWF TR5,W	;F-W -> W
LABEL_TR5_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR5_ENDE

LABEL_TR5_RESET
	MOVLW 7	; Test auf >=
	SUBWF TR5_HI,F	;F-W -> F
	MOVLW 161
	SUBWF TR5,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR5_HI,F

LABEL_TR5_SET	; toggel output
	BTFSC S4,6
	GOTO LABEL_TR5_CLR
	BSF S4,6
	GOTO LABEL_TR5_ENDE
LABEL_TR5_CLR
	BCF S4,6
LABEL_TR5_ENDE

;***************************************************
; Unterprogramm TAB aufrufen
;***************************************************

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVFW ZR2

	CALL TAB

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVWF S0

	BSF INTCON,GIE
;***************************************************
; Vergleich -> IF2
;***************************************************

	MOVLW 5
	SUBWF ZR2,W	; F - W -> W

LABEL_IF2_CHECK
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS STATUS,ZERO	; Test auf -> =
	GOTO LABEL_IF2_FALSE

LABEL_IF2_TRUE
	BSF S4,7
	GOTO LABEL_IF2_EXIT

LABEL_IF2_FALSE
	BCF S4,7

LABEL_IF2_EXIT
;***************************************************
; UND - Gatter -> LG15
;***************************************************

LABEL_LG15_1
	BTFSS S2,5
	GOTO LABEL_LG15_FALSE
LABEL_LG15_2
	BTFSC S2,0
	GOTO LABEL_LG15_FALSE
LABEL_LG15_3
	BTFSS PORTA,0
	GOTO LABEL_LG15_FALSE

LABEL_LG15_TRUE
	BSF S7,0
	GOTO LABEL_LG15_ENDE
LABEL_LG15_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S7,0
LABEL_LG15_ENDE
;***************************************************
; UND - Gatter -> LG16
;***************************************************

LABEL_LG16_1
	BTFSS S2,6
	GOTO LABEL_LG16_FALSE
LABEL_LG16_2
	BTFSS S5,6
	GOTO LABEL_LG16_FALSE

LABEL_LG16_TRUE
	BSF S5,7
	GOTO LABEL_LG16_ENDE
LABEL_LG16_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S5,7
LABEL_LG16_ENDE
;***************************************************
; UND - Gatter -> LG17
;***************************************************

LABEL_LG17_1
	BTFSS S6,4
	GOTO LABEL_LG17_FALSE
LABEL_LG17_2
	BTFSS S4,4
	GOTO LABEL_LG17_FALSE

LABEL_LG17_TRUE
	BSF S6,7
	GOTO LABEL_LG17_ENDE
LABEL_LG17_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S6,7
LABEL_LG17_ENDE
;***************************************************
; UND - Gatter -> LG18
;***************************************************

LABEL_LG18_1
	BTFSS S6,5
	GOTO LABEL_LG18_FALSE
LABEL_LG18_2
	BTFSS S4,0
	GOTO LABEL_LG18_FALSE
LABEL_LG18_3
	BTFSS PORTA,0
	GOTO LABEL_LG18_FALSE

LABEL_LG18_TRUE
	BSF S5,0
	GOTO LABEL_LG18_ENDE
LABEL_LG18_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S5,0
LABEL_LG18_ENDE
;***************************************************
; UND - Gatter -> LG19
;***************************************************

LABEL_LG19_1
	BTFSS S6,2
	GOTO LABEL_LG19_FALSE
LABEL_LG19_2
	BTFSS S3,7
	GOTO LABEL_LG19_FALSE
LABEL_LG19_3
	BTFSS PORTA,0
	GOTO LABEL_LG19_FALSE

LABEL_LG19_TRUE
	BSF S5,2
	GOTO LABEL_LG19_ENDE
LABEL_LG19_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S5,2
LABEL_LG19_ENDE
;***************************************************
; One Shot -> OS9
;***************************************************


	BTFSS S7,0
	GOTO LABEL_OS9_1
	BTFSC OS9_FD,0
	GOTO LABEL_OS9_1
	BSF OS9_FD,0
	BSF S5,5
	GOTO LABEL_OS9_2
LABEL_OS9_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S5,5
	BTFSC S7,0
	GOTO LABEL_OS9_2
	BCF OS9_FD,0
LABEL_OS9_2
;***************************************************
; One Shot -> OS10
;***************************************************


	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S5,7
	GOTO LABEL_OS10_1
	BTFSC OS10_FD,0
	GOTO LABEL_OS10_1
	BSF OS10_FD,0
	BSF S5,4
	GOTO LABEL_OS10_2
LABEL_OS10_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S5,4
	BTFSC S5,7
	GOTO LABEL_OS10_2
	BCF OS10_FD,0
LABEL_OS10_2
;***************************************************
; One Shot -> OS11
;***************************************************


	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S6,7
	GOTO LABEL_OS11_1
	BTFSC OS11_FD,0
	GOTO LABEL_OS11_1
	BSF OS11_FD,0
	BSF S6,6
	GOTO LABEL_OS11_2
LABEL_OS11_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S6,6
	BTFSC S6,7
	GOTO LABEL_OS11_2
	BCF OS11_FD,0
LABEL_OS11_2
;***************************************************
; One Shot -> OS12
;***************************************************


	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S5,0
	GOTO LABEL_OS12_1
	BTFSC OS12_FD,0
	GOTO LABEL_OS12_1
	BSF OS12_FD,0
	BSF S5,1
	GOTO LABEL_OS12_2
LABEL_OS12_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S5,1
	BTFSC S5,0
	GOTO LABEL_OS12_2
	BCF OS12_FD,0
LABEL_OS12_2
;***************************************************
; One Shot -> OS13
;***************************************************


	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S5,2
	GOTO LABEL_OS13_1
	BTFSC OS13_FD,0
	GOTO LABEL_OS13_1
	BSF OS13_FD,0
	BSF S5,3
	GOTO LABEL_OS13_2
LABEL_OS13_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S5,3
	BTFSC S5,2
	GOTO LABEL_OS13_2
	BCF OS13_FD,0
LABEL_OS13_2
;***************************************************
; LCD -> LT9
;***************************************************

; test of positiv edge

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC LT9_FD,0
	GOTO LABEL_LT9_SETFD
	BTFSS S6,0
	GOTO LABEL_LT9_SETFD


	MOVLW 0
	MOVWF SYS_TMP1
	MOVLW 1
	MOVWF SYS_TMP2

	CALL LCD_LB1_GOTOXY

	MOVLW LOW TAB_LT9
	MOVWF SYS_TMP4
	MOVLW HIGH TAB_LT9
	MOVWF SYS_TMP5


	CALL LCD_LB1_WRITESTR

LABEL_LT9_SETFD

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S6,0
	GOTO LABEL_LT9_SETFD2
	BSF LT9_FD,0
	GOTO LABEL_LT9_END
LABEL_LT9_SETFD2
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF LT9_FD,0
LABEL_LT9_END

;***************************************************
; One Shot -> OS14
;***************************************************


	BTFSS S6,1
	GOTO LABEL_OS14_1
	BTFSC OS14_FD,0
	GOTO LABEL_OS14_1
	BSF OS14_FD,0
	BSF S6,0
	GOTO LABEL_OS14_2
LABEL_OS14_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S6,0
	BTFSC S6,1
	GOTO LABEL_OS14_2
	BCF OS14_FD,0
LABEL_OS14_2
;***************************************************
; UND - Gatter -> LG20
;***************************************************

LABEL_LG20_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S6,3
	GOTO LABEL_LG20_FALSE
LABEL_LG20_2
	BTFSS S3,6
	GOTO LABEL_LG20_FALSE
LABEL_LG20_3
	BTFSS PORTA,0
	GOTO LABEL_LG20_FALSE

LABEL_LG20_TRUE
	BSF S6,1
	GOTO LABEL_LG20_ENDE
LABEL_LG20_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S6,1
LABEL_LG20_ENDE
;***************************************************
; One Shot -> OS15
;***************************************************


	BTFSS PORTA,0
	GOTO LABEL_OS15_1
	BTFSC OS15_FD,0
	GOTO LABEL_OS15_1
	BSF OS15_FD,0
	BSF S7,3
	GOTO LABEL_OS15_2
LABEL_OS15_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S7,3
	BTFSC PORTA,0
	GOTO LABEL_OS15_2
	BCF OS15_FD,0
LABEL_OS15_2
;***************************************************
; RS-FLIP-FLOP -> RS2
;***************************************************

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS PORTA,0
	GOTO LABEL_RS2_RESET
	BTFSS PORTB,6
	GOTO LABEL_RS2_ENDE
	BSF PORTA,6	; Ausgang setzen
	GOTO LABEL_RS2_ENDE
LABEL_RS2_RESET
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF PORTA,6	; Ausgang zurcksetzen
LABEL_RS2_ENDE

;***************************************************
; RS-FLIP-FLOP -> RS3
;***************************************************

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S7,5
	GOTO LABEL_RS3_RESET
	BTFSS PORTA,1
	GOTO LABEL_RS3_ENDE
	BSF S4,0	; Ausgang setzen
	GOTO LABEL_RS3_ENDE
LABEL_RS3_RESET
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S4,0	; Ausgang zurcksetzen
LABEL_RS3_ENDE

;***************************************************
; RS-FLIP-FLOP -> RS4
;***************************************************

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S7,5
	GOTO LABEL_RS4_RESET
	BTFSS PORTA,2
	GOTO LABEL_RS4_ENDE
	BSF S3,7	; Ausgang setzen
	GOTO LABEL_RS4_ENDE
LABEL_RS4_RESET
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S3,7	; Ausgang zurcksetzen
LABEL_RS4_ENDE

;***************************************************
; RS-FLIP-FLOP -> RS5
;***************************************************

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S7,5
	GOTO LABEL_RS5_RESET
	BTFSS PORTA,3
	GOTO LABEL_RS5_ENDE
	BSF S3,6	; Ausgang setzen
	GOTO LABEL_RS5_ENDE
LABEL_RS5_RESET
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S3,6	; Ausgang zurcksetzen
LABEL_RS5_ENDE

;***************************************************
; RS-FLIP-FLOP -> RS6
;***************************************************

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S7,5
	GOTO LABEL_RS6_RESET
	BTFSS PORTA,4
	GOTO LABEL_RS6_ENDE
	BSF S4,4	; Ausgang setzen
	GOTO LABEL_RS6_ENDE
LABEL_RS6_RESET
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S4,4	; Ausgang zurcksetzen
LABEL_RS6_ENDE

;***************************************************
; One Shot -> OS16
;***************************************************


	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS PORTA,7
	GOTO LABEL_OS16_1
	BTFSC OS16_FD,0
	GOTO LABEL_OS16_1
	BSF OS16_FD,0
	BSF S7,5
	GOTO LABEL_OS16_2
LABEL_OS16_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S7,5
	BTFSC PORTA,7
	GOTO LABEL_OS16_2
	BCF OS16_FD,0
LABEL_OS16_2
;****************************************

	GOTO MAIN


TAB_LT1
	RETLW 65	; A
	RETLW 108	; l
	RETLW 108	; l
	RETLW 97	; a
	RETLW 114	; r
	RETLW 109	; m
	RETLW 101	; e
	RETLW 32	;  
	RETLW 100	; d
	RETLW 105	; i
	RETLW 115	; s
	RETLW 105	; i
	RETLW 110	; n
	RETLW 115	; s
	RETLW 101	; e
	RETLW 114	; r
	RETLW 105	; i
	RETLW 116	; t
	RETLW 111	; o
	RETLW 32	;  
	RETLW 0	; end


TAB_LT2
	RETLW 84	; T
	RETLW 97	; a
	RETLW 109	; m
	RETLW 112	; p
	RETLW 101	; e
	RETLW 114	; r
	RETLW 32	;  
	RETLW 50	; 2
	RETLW 52	; 4
	RETLW 104	; h
	RETLW 32	;  
	RETLW 105	; i
	RETLW 110	; n
	RETLW 115	; s
	RETLW 101	; e
	RETLW 114	; r
	RETLW 105	; i
	RETLW 116	; t
	RETLW 111	; o
	RETLW 0	; end


TAB_LT3
	RETLW 65	; A
	RETLW 108	; l
	RETLW 108	; l
	RETLW 97	; a
	RETLW 114	; r
	RETLW 109	; m
	RETLW 101	; e
	RETLW 32	;  
	RETLW 105	; i
	RETLW 110	; n
	RETLW 115	; s
	RETLW 101	; e
	RETLW 114	; r
	RETLW 105	; i
	RETLW 116	; t
	RETLW 111	; o
	RETLW 32	;  
	RETLW 32	;  
	RETLW 32	;  
	RETLW 0	; end


TAB_LT4
	RETLW 67	; C
	RETLW 111	; o
	RETLW 110	; n
	RETLW 116	; t
	RETLW 114	; r
	RETLW 111	; o
	RETLW 108	; l
	RETLW 108	; l
	RETLW 111	; o
	RETLW 32	;  
	RETLW 108	; l
	RETLW 105	; i
	RETLW 110	; n
	RETLW 101	; e
	RETLW 101	; e
	RETLW 32	;  
	RETLW 32	;  
	RETLW 32	;  
	RETLW 32	;  
	RETLW 0	; end


TAB_LT5
	RETLW 76	; L
	RETLW 105	; i
	RETLW 110	; n
	RETLW 101	; e
	RETLW 101	; e
	RETLW 32	;  
	RETLW 105	; i
	RETLW 110	; n
	RETLW 32	;  
	RETLW 97	; a
	RETLW 116	; t
	RETLW 116	; t
	RETLW 101	; e
	RETLW 115	; s
	RETLW 97	; a
	RETLW 32	;  
	RETLW 32	;  
	RETLW 32	;  
	RETLW 32	;  
	RETLW 0	; end


TAB_LT6
	RETLW 69	; E
	RETLW 102	; f
	RETLW 102	; f
	RETLW 114	; r
	RETLW 97	; a
	RETLW 122	; z
	RETLW 105	; i
	RETLW 111	; o
	RETLW 110	; n
	RETLW 101	; e
	RETLW 32	;  
	RETLW 84	; T
	RETLW 97	; a
	RETLW 109	; m
	RETLW 112	; p
	RETLW 101	; e
	RETLW 114	; r
	RETLW 32	;  
	RETLW 33	; !
	RETLW 0	; end


TAB_LT7
	RETLW 65	; A
	RETLW 108	; l
	RETLW 108	; l
	RETLW 97	; a
	RETLW 114	; r
	RETLW 109	; m
	RETLW 101	; e
	RETLW 32	;  
	RETLW 90	; Z
	RETLW 79	; O
	RETLW 78	; N
	RETLW 65	; A
	RETLW 32	;  
	RETLW 49	; 1
	RETLW 32	;  
	RETLW 33	; !
	RETLW 33	; !
	RETLW 33	; !
	RETLW 32	;  
	RETLW 0	; end


TAB_LT8
	RETLW 65	; A
	RETLW 108	; l
	RETLW 108	; l
	RETLW 97	; a
	RETLW 114	; r
	RETLW 109	; m
	RETLW 101	; e
	RETLW 32	;  
	RETLW 90	; Z
	RETLW 79	; O
	RETLW 78	; N
	RETLW 65	; A
	RETLW 32	;  
	RETLW 50	; 2
	RETLW 32	;  
	RETLW 33	; !
	RETLW 33	; !
	RETLW 33	; !
	RETLW 32	;  
	RETLW 0	; end


TAB_LT9
	RETLW 65	; A
	RETLW 108	; l
	RETLW 108	; l
	RETLW 97	; a
	RETLW 114	; r
	RETLW 109	; m
	RETLW 101	; e
	RETLW 32	;  
	RETLW 90	; Z
	RETLW 79	; O
	RETLW 78	; N
	RETLW 65	; A
	RETLW 32	;  
	RETLW 51	; 3
	RETLW 32	;  
	RETLW 33	; !
	RETLW 33	; !
	RETLW 33	; !
	RETLW 32	;  
	RETLW 0	; end

	ORG 2036
;***************************************************
; Table -> TAB
;***************************************************

TAB

	MOVWF SYS_TMP1
	MOVLW HIGH TAB_WERTE
	MOVWF PCLATH
	MOVFW SYS_TMP1
	BCF INTCON,GIE
	ADDWF PCL,F

TAB_WERTE

	RETLW 1	; // INDEX 0
	RETLW 2	; // INDEX 1
	RETLW 4	; // INDEX 2
	RETLW 8	; // INDEX 3
	RETLW 16	; // INDEX 4
	RETLW 0	; // INDEX 5


	END

